SystemOrganization addCategory: #'Questionnaire-Model'!

WAComponent subclass: #SQComponent
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

!SQComponent class methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:43'!
on: model
	^self new model: model; yourself! !

!SQComponent methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:06'!
model
	^ model! !

!SQComponent methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:41'!
model1
	^ model! !

!SQComponent methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:41'!
model1: anObject
	model := anObject! !

!SQComponent methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:06'!
model: anObject
	model := anObject! !

SQComponent subclass: #SQQuestionRenderer
	instanceVariableNames: 'results'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

!SQQuestionRenderer methodsFor: 'rendering' stamp: 'obi 9/26/2010 11:19'!
renderAnswersFor: aQuestion on: html
	
	| isMulti |
	aQuestion isComment
		ifTrue: [self renderTextInputFor: aQuestion on: html ]
		ifFalse: [
			isMulti := aQuestion isMultiple.
			isMulti
				ifTrue: [self renderMultipleChoiceFor: aQuestion on: html ]
				ifFalse: [self renderSingleChoiceFor: aQuestion on: html ] ]! !

!SQQuestionRenderer methodsFor: 'rendering' stamp: 'obi 9/28/2010 20:17'!
renderContentOn: html
	
	html div
		class: 'questions';
		with: [
			html table
				cellspacing: 0;
				with: [
					model do: [:each |
						each isGroup
							ifTrue: [self renderGroup: each on: html]
							ifFalse: [self renderQuestion: each on: html ] ] ] ]! !

!SQQuestionRenderer methodsFor: 'rendering' stamp: 'obi 9/28/2010 21:05'!
renderGroup: each on: html
	
	| isMulti |
	html tableRow: [
		html tableHeading
				colSpan: 99;
				with: each title ] .
	html tableRow
		class: 'answer';
		with: [
			html tableData colSpan: 99; with: [
				html table: [
					html tableRow: [
						html tableData; tableData.
						each answers do: [:answer |
							html tableData class: 'groupWidth center'; with: answer text]
						].
					each questions withIndexDo: [:aQuestion :idx |
						html tableRow
							class: 'even' if: idx even ;
							class: 'odd' if: idx odd;
							with: [
								html tableData: aQuestion number asString, '. '.
								html tableData style: 'width:200px'; with: aQuestion title.
						isMulti := aQuestion isMultiple.
							isMulti
							ifTrue: [self renderMultipleChoiceFor: aQuestion showText: false on: html ]
							ifFalse: [self renderSingleChoiceFor: aQuestion showText: false on: html ] ] ] ] ] ]
			
		! !

!SQQuestionRenderer methodsFor: 'rendering' stamp: 'obi 9/28/2010 20:19'!
renderMultipleChoiceFor: aQuestion on: html
	self renderMultipleChoiceFor: aQuestion showText: true on: html! !

!SQQuestionRenderer methodsFor: 'rendering' stamp: 'obi 9/28/2010 20:33'!
renderMultipleChoiceFor: aQuestion showText: aBoolean on: html
	aQuestion answers do: [:answer | 
			html tableData
				class: 'center' if: aBoolean not;
				with: [
					html checkbox
						callback: [:value | value ifTrue: [ (self results at: aQuestion ifAbsentPut: [Set new]) add: answer ] ];
						value: ((self results at: aQuestion ifAbsent: [#()]) includes: answer).
					aBoolean ifTrue: [ html label: answer text ] ] ] ! !

!SQQuestionRenderer methodsFor: 'rendering' stamp: 'obi 9/28/2010 20:16'!
renderQuestion: each on: html

	html tableRow: [
		html tableHeading
				colSpan: 99;
				with: [
					html text: each number. 
					html text: '.'; space.
					html text: each title ] ].
	html tableRow
			class: 'answer';
			with: [self renderAnswersFor: each on: html].
	html tableRow
			class: 'blank';
			with: [html tableData] ! !

!SQQuestionRenderer methodsFor: 'rendering' stamp: 'obi 9/28/2010 20:18'!
renderSingleChoiceFor: aQuestion on: html
	self renderSingleChoiceFor: aQuestion showText: true on: html! !

!SQQuestionRenderer methodsFor: 'rendering' stamp: 'obi 9/28/2010 20:33'!
renderSingleChoiceFor: aQuestion showText: aBoolean on: html
		html radioGroup
			callback: [:value | self results at: aQuestion put: value ];
			selected: (self results at: aQuestion ifAbsent: []);
			with: [:group |
					aQuestion answers do: [:answer |
						html tableData
							class: 'center' if: aBoolean not;
							with:
								[html radioButton
									group: group;
									value: answer.
								aBoolean ifTrue: [html label: answer text ] ] ]  ]  ! !

!SQQuestionRenderer methodsFor: 'rendering' stamp: 'obi 9/26/2010 11:28'!
renderTextInputFor: aQuestion on: html
	
	aQuestion answers do: [:answer |
		html tableData colSpan: 99;
			with: [ | currentAnswer | 
				currentAnswer := self results at: aQuestion ifAbsent: [].
				html textArea
					style: 'width:99%';
					rows: 5;
					callback: [:value | answer text: value.
									 self results at: aQuestion put: answer];
					value: (currentAnswer isNil ifTrue: [''] ifFalse: [answer text] ) ] ]! !

!SQQuestionRenderer methodsFor: 'accessing' stamp: 'obi 9/25/2010 19:38'!
reset
	results := nil! !

!SQQuestionRenderer methodsFor: 'accessing' stamp: 'obi 9/25/2010 19:24'!
results
	results ifNil: [results := Dictionary new].
	^results! !

!SQQuestionRenderer methodsFor: 'accessing' stamp: 'obi 9/25/2010 19:14'!
results: anObject
	results := anObject! !

SQComponent subclass: #SQResultRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

!SQResultRenderer methodsFor: 'rendering' stamp: 'obi 9/28/2010 20:48'!
renderContentOn: html
	| resultDict pixelPerEntry |
	html div class: 'survey';
		with: [
			html heading: 'Results'.
			model allQuestions do: [:each |
				html div class: 'question'; with: each number asString, '. ', each title.
				resultDict := each resultDictionary.
				pixelPerEntry := 400 // ((each results size // 2) max: 1).
				each answers do: [:answer | | numberOfEntries |
					html div class: 'result';
						with: [
							html div style: 'float:left;width:200px'; with: answer text.
							numberOfEntries := (resultDict at: answer ifAbsent: [#()]) size.
							html div style: 'float:left;background-color:blue;width:', (numberOfEntries * pixelPerEntry) asString, 'px'; with: [html space].
							html div style: 'margin-left:4px;float:left'; with: numberOfEntries.
							html div style: 'clear:both'] ].
				html break.]]! !

!SQResultRenderer methodsFor: 'rendering' stamp: 'obi 9/25/2010 19:07'!
style
	^'
	.survey {width:700px;margin-left:auto; margin-right:auto;font-family:Arial}
	.question {text-align: left; background:#FFFF8A;color:#006;padding:4px;font-size:18px;font-weight:normal;margin-bottom:3px}
	.result {padding:2px}
	'! !

SQComponent subclass: #SQSurveyEditor
	instanceVariableNames: 'questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

!SQSurveyEditor class methodsFor: 'class initialization' stamp: 'obi 9/28/2010 20:07'!
initialize
	WAAdmin register: self asApplicationAt: 'questionnaire/editor'! !

!SQSurveyEditor methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:11'!
children
	^Array with: questions ! !

!SQSurveyEditor methodsFor: 'private' stamp: 'obi 9/28/2010 20:43'!
createExample
	| survey myAnswers myMultiAnswers group |
	self model: (survey := SQSurvey new).
	survey title: 'Example Questionnaire'.
	myAnswers := OrderedCollection new.
	myAnswers add: (SQAnswer new text: 'Sehr gut'; value: 1; yourself).
	myAnswers add: (SQAnswer new text: 'Gut'; value: 2; yourself).
	myAnswers add: (SQAnswer new text: 'Befriedigend'; value: 3; yourself).
	myAnswers add: (SQAnswer new text: 'Gengend'; value: 4; yourself).
	myAnswers add: (SQAnswer new text: 'Nicht Gengend'; value: 5; yourself).
	myMultiAnswers := OrderedCollection new.
	myMultiAnswers add: (SQAnswer new text: 'Vienna'; value: 1; yourself).
	myMultiAnswers add: (SQAnswer new text: 'Berlin'; value: 2; yourself).
	myMultiAnswers add: (SQAnswer new text: 'New York'; value: 3; yourself).
	myMultiAnswers add: (SQAnswer new text: 'Paris'; value: 4; yourself).
	myMultiAnswers add: (SQAnswer new text: 'Other'; value: 5; yourself).
	survey add: (SQQuestion new title: 'Do you like ice cream?'; number: 1; answers: myAnswers; yourself).
	survey add: (SQQuestion new title: 'Do you like chocolate?'; number: 2; answers: myAnswers; yourself).
	survey add: (SQMultipleChoiceQuestion new title: 'Which cities have you visited?'; number: 3; answers: myMultiAnswers; yourself).
	group := SQQuestionGroup new title: 'Please fill out the following questions:'; answers: myAnswers; yourself.
	group add: (SQQuestion new title: 'How do you feel?'; number: 4; yourself).
	group add: (SQQuestion new title: 'How do you like yourself?'; number: 5; yourself).
	group add: (SQQuestion new title: 'How do you like your hobbies?'; number: 6; yourself).
	survey add: group.
	survey add: (SQCommentQuestion new title: 'Do you have some comments?'; number: 7; answers: (Array with: SQComment new); yourself)
	! !

!SQSurveyEditor methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:46'!
model: aSurvey
	super model: aSurvey.
	questions := SQQuestionRenderer on: aSurvey questions! !

!SQSurveyEditor methodsFor: 'rendering' stamp: 'obi 9/28/2010 20:08'!
renderContentOn: html
	model isNil ifTrue: [^self renderExampleOn: html].
	html div class: 'survey';
		with: [
			html heading: model title.
			html form: [
				html heading level2 with: model introText.
				html render: questions.
				html heading level2 with: model finalText.
				html submitButton
					callback: [ self save ];
					value: 'Finish'.
				html space: 2.
				html submitButton
					callback: [self show: (SQResultRenderer on: model)];
					value: 'Show results' ] ]! !

!SQSurveyEditor methodsFor: 'rendering' stamp: 'obi 9/24/2010 23:02'!
renderExampleOn: html
	html anchor callback: [self createExample]; with: 'Create example'! !

!SQSurveyEditor methodsFor: 'actions' stamp: 'obi 9/28/2010 20:45'!
save
	| sum |
	sum := 0.
	model questions do: [:each | sum := sum + each getSize ].
	sum = questions results size
					ifFalse: [self inform: 'Please fill out every question!!']
					ifTrue: [	questions results keysAndValuesDo: [:question :answer |  question addResultFor: answer].
							questions reset].
					 ! !

!SQSurveyEditor methodsFor: 'rendering' stamp: 'obi 9/28/2010 21:05'!
style
	^'
	.survey {width:700px;margin-left:auto; margin-right:auto;font-family:Arial}
	.questions th {text-align: left; background:#FFFF8A;color:#006;padding:4px;font-size:18px;font-weight:normal}
	.questions .answer {background-color:#FEFFCD}
	.groupWidth {width:90px}
	.even {background-color:#e5e5e5}
	.odd {background-color:#fff}
	.questions td {padding:4px}
	.center {text-align:center}'! !

Object subclass: #SQModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

Object subclass: #SQObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

SQObject subclass: #SQAnswer
	instanceVariableNames: 'text value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

!SQAnswer methodsFor: 'accessing' stamp: 'obi 9/25/2010 18:40'!
asResult
	^SQResult new answer: self; value: value; yourself! !

!SQAnswer methodsFor: 'testing' stamp: 'obi 9/26/2010 09:00'!
isMultiple
	^false! !

!SQAnswer methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:05'!
text
	^ text! !

!SQAnswer methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:05'!
text: anObject
	text := anObject! !

!SQAnswer methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:05'!
value
	^ value! !

!SQAnswer methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:05'!
value: anObject
	value := anObject! !

SQObject subclass: #SQComment
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

!SQComment methodsFor: 'accessing' stamp: 'obi 9/26/2010 11:31'!
asResult
	^self text isEmpty
		ifFalse: [SQResult new answer: self; value: self text; yourself]
		ifTrue: []! !

!SQComment methodsFor: 'accessing' stamp: 'obi 9/26/2010 11:08'!
text
	text ifNil: [text := ''].
	^text! !

!SQComment methodsFor: 'accessing' stamp: 'obi 9/26/2010 11:08'!
text: anObject
	text := anObject! !

!SQObject methodsFor: 'testing' stamp: 'obi 9/24/2010 23:13'!
isGroup
	^false! !

SQObject subclass: #SQQuestion
	instanceVariableNames: 'title number parent results answers mandatory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

SQQuestion subclass: #SQCommentQuestion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

!SQCommentQuestion methodsFor: 'testing' stamp: 'obi 9/26/2010 11:18'!
isComment
	^true! !

!SQCommentQuestion methodsFor: 'accessing' stamp: 'obi 9/26/2010 11:14'!
mandatoryDefault
	^false! !

SQQuestion subclass: #SQMultipleChoiceQuestion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

!SQMultipleChoiceQuestion methodsFor: 'accessing' stamp: 'obi 9/26/2010 09:24'!
addResultFor:  anAnswerSet
	anAnswerSet do: [:anAnswer | super addResultFor:  anAnswer ]
! !

!SQMultipleChoiceQuestion methodsFor: 'testing' stamp: 'obi 9/26/2010 09:19'!
isMultiple
	^true! !

!SQQuestion methodsFor: 'public' stamp: 'obi 9/26/2010 11:32'!
addResultFor:  anAnswer
	| myResult |
	myResult := anAnswer asResult.
	myResult isNil ifFalse: [ self results add: myResult ]! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:30'!
answers
	parent isNil ifFalse: [^parent answers].
	^answers! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:05'!
answers: anObject
	answers := anObject! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:48'!
getQuestions
	^Array with: self! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:45'!
getSize
	^1! !

!SQQuestion methodsFor: 'initialize-release' stamp: 'obi 9/26/2010 11:14'!
initialize
	super initialize.
	mandatory := self mandatoryDefault! !

!SQQuestion methodsFor: 'testing' stamp: 'obi 9/26/2010 11:18'!
isComment
	^false! !

!SQQuestion methodsFor: 'testing' stamp: 'obi 9/26/2010 09:19'!
isMultiple
	^false! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/26/2010 11:12'!
mandatory
	^ mandatory! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/26/2010 11:12'!
mandatory: anObject
	mandatory := anObject! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/26/2010 11:14'!
mandatoryDefault
	^true! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:05'!
number
	^ number! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:05'!
number: anObject
	number := anObject! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:29'!
parent
	^ parent! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:29'!
parent: anObject
	parent := anObject! !

!SQQuestion methodsFor: 'rendering' stamp: 'obi 9/24/2010 22:36'!
renderOn: html
	html text: title.
	self answers do: [:each | html render: each ]! !

!SQQuestion methodsFor: 'public' stamp: 'obi 9/25/2010 18:49'!
resultDictionary
	| dict |
	dict := Dictionary new.
	self results do: [:each | | aColl |
		aColl := dict at: each answer ifAbsentPut: [OrderedCollection new].
		aColl add: each
		].
	^dict! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/25/2010 18:27'!
results
	results ifNil: [results := OrderedCollection new].
	^results! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:05'!
results: anObject
	results := anObject! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:05'!
title
	^ title! !

!SQQuestion methodsFor: 'accessing' stamp: 'obi 9/24/2010 23:05'!
title: anObject
	title := anObject! !

SQObject subclass: #SQQuestionGroup
	instanceVariableNames: 'title answers questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

!SQQuestionGroup methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:29'!
add: aQuestion
	self questions add: aQuestion.
	aQuestion parent: self! !

!SQQuestionGroup methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:10'!
answers
	^ answers! !

!SQQuestionGroup methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:10'!
answers: anObject
	answers := anObject! !

!SQQuestionGroup methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:50'!
getQuestions
	^self questions! !

!SQQuestionGroup methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:45'!
getSize
	^self questions size! !

!SQQuestionGroup methodsFor: 'testing' stamp: 'obi 9/24/2010 23:13'!
isGroup
	^true! !

!SQQuestionGroup methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:11'!
questions
	questions ifNil: [questions := OrderedCollection new].
	^questions ! !

!SQQuestionGroup methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:11'!
questions: anObject
	questions := anObject! !

!SQQuestionGroup methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:10'!
title
	^ title! !

!SQQuestionGroup methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:10'!
title: anObject
	title := anObject! !

SQObject subclass: #SQResult
	instanceVariableNames: 'answer value comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

!SQResult methodsFor: 'accessing' stamp: 'obi 9/25/2010 18:40'!
answer
	^ answer! !

!SQResult methodsFor: 'accessing' stamp: 'obi 9/25/2010 18:40'!
answer: anObject
	answer := anObject! !

!SQResult methodsFor: 'accessing' stamp: 'obi 9/25/2010 18:25'!
comment
	^ comment! !

!SQResult methodsFor: 'accessing' stamp: 'obi 9/25/2010 18:25'!
comment: anObject
	comment := anObject! !

!SQResult methodsFor: 'accessing' stamp: 'obi 9/25/2010 18:25'!
value
	^ value! !

!SQResult methodsFor: 'accessing' stamp: 'obi 9/25/2010 18:25'!
value: anObject
	value := anObject! !

SQObject subclass: #SQSurvey
	instanceVariableNames: 'start end questions title introText finalText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Questionnaire-Model'!

!SQSurvey methodsFor: 'public' stamp: 'obi 9/24/2010 22:25'!
add: aQuestion
	self questions add: aQuestion! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/28/2010 20:48'!
allQuestions
	| result |
	result := OrderedCollection new.
	self questions do: [:each | result addAll: each getQuestions].
	^result! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:23'!
end
	^ end! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:27'!
end: anObject
	end ifNil: [end := self start addDays: 30].
	^end! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:24'!
finalText
	^ finalText! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:24'!
finalText: anObject
	finalText := anObject! !

!SQSurvey methodsFor: 'public' stamp: 'obi 9/25/2010 17:38'!
initialize
	super initialize.
	title := 'No title'.
	finalText  := 'Thank you'.
	introText   := 'Please fill out the following questions'.! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:24'!
introText
	^ introText! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:24'!
introText: anObject
	introText := anObject! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:26'!
questions
	questions ifNil: [questions := OrderedCollection new].
	^questions ! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:24'!
questions: anObject
	questions := anObject! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:26'!
start
	start ifNil: [start := Date today].
	^start! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:24'!
start: anObject
	start := anObject! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:24'!
title
	^ title! !

!SQSurvey methodsFor: 'accessing' stamp: 'obi 9/24/2010 22:24'!
title: anObject
	title := anObject! !
SQSurveyEditor initialize!
